#!/usr/bin/env perl

use IPC::Open2;

my @specs=glob("*.spec");

chdir "..";

my ($read, $write);
my $spec;

for my $test (@specs){
    substr $test, -5, 5, "";
    my $fail=0;
    
    open2($read, $write, "./atemu", "-t", "tests/$test.srec");

    # run the program
    print $write "g\n";
    
    while(!(<$read> =~ m/TEST END/)){
    }

    open $spec, "tests/$test.spec";
    while(my $line = <$spec>){
        chomp $line;
        if ($line eq ""){
            next;
        }
        my @spec = ($line =~ m/(\d{6}):\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*/);

        print $write "d $spec[0]\n";
        my $values=<$read>;
        chomp $values;
        my @program = ($values =~ m/(\d{6}):\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*(\d\d)\s*/);

        # compare in and out values
        for my $i (1 .. 16){
            if($spec[$i] ne $program[$i]){
                $fail++;
                print "FAILURE on test $test at address $spec[0].\n";
                print "Spec value $i was $spec[$i], program was $program[$i].\n";
            }
        }
    }

    print $write "q\n";
    close $read;
    close $write;
    
    if($fail==0){
        print "Test $test PASSED.\n";
    }
}


